local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

function SHFrame_OnLoad()
	SHFrame:RegisterEvent("VARIABLES_LOADED")
	SHFrame:RegisterEvent("UNIT_AURA")
	
	SlashCmdList["SHSETTINGS"] = checksettings
		SlashCmdList_SHSETTINGS1 = "/sh"
end

function SHFrame_OnEvent(self, event, arg1)

if event == "VARIABLES_LOADED" then
	if SHConfig == "" or SHConfig == nil then
		SHConfig = {
			["TakingSelfie"] = 'NO',
			["OwnName"] = 'OFF',
			["GuildName"] = 'OFF',
			["FriendlyPlayerName"] = 'OFF',
			["FriendlyPetName"] = 'OFF',
			["EnemyPlayerName"] = 'OFF',
			["EnemyPetName"] = 'OFF',
			["NPCName"] = 'OFF',
			["NamePlates"] = '0',
			["FriendlyGuardianName"] = 'OFF',
			["EnemyGuardianName"] = 'OFF',
			["CompanionName"] = 'OFF'
		}
	end
	
	if SHConfig.FriendlyGuardianName == nil or SHConfig.FriendlyGuardianName == "" then
		SHConfig.FriendlyGuardianName = 'OFF'
	end
	
	if SHConfig.EnemyGuardianName == nil or SHConfig.EnemyGuardianName == "" then
		SHConfig.EnemyGuardianName = 'OFF'
	end
	
	if SHConfig.CompanionName == nil or SHConfig.CompanionName == "" then
		SHConfig.CompanionName = 'OFF'
	end
	
	checksettings()
elseif event == "UNIT_AURA" then
	if AuraUtil.FindAuraByName(L["S.E.L.F.I.E. Camera"], "player") or AuraUtil.FindAuraByName(L["S.E.L.F.I.E. Camera MkII"], "player") then	
		if SHConfig.TakingSelfie == "NO" then
		
			if IsAddOnLoaded("TomTom") == true then
				TomTomBlock:Hide()
			end
		
			if IsAddOnLoaded("Decursive") == true then
				DcrMUFsContainer:Hide()
			end
		
			SHConfig.TakingSelfie = 'YES'
			
			if GetCVar("UnitNameOwn") == "1" then SetCVar("UnitNameOwn", "0") end
			if GetCVar("UnitNamePlayerGuild") == "1" then SetCVar("UnitNamePlayerGuild", "0") end
			if GetCVar("UnitNameFriendlyPlayerName") == "1" then SetCVar("UnitNameFriendlyPlayerName", "0") end
			if GetCVar("UnitNameFriendlyPetName") == "1" then SetCVar("UnitNameFriendlyPetName", "0") end
			if GetCVar("UnitNameEnemyPlayerName") == "1" then SetCVar("UnitNameEnemyPlayerName", "0") end
			if GetCVar("UnitNameEnemyPetName") == "1" then SetCVar("UnitNameEnemyPetName", "0") end
			if GetCVar("UnitNameNPC") == "1" then SetCVar("UnitNameNPC", "0") end
			if GetCVar("nameplateMaxDistance") >= "0" then SetCVar("nameplateMaxDistance", "0") end
			if GetCVar("UnitNameFriendlyGuardianName") == "1" then SetCVar("UnitNameFriendlyGuardianName", "0") end
			if GetCVar("UnitNameEnemyGuardianName") == "1" then SetCVar("UnitNameEnemyGuardianName", "0") end
			if GetCVar("UnitNameCompanionName") == "1" then SetCVar("UnitNameCompanionName", "0") end
		elseif SHConfig.TakingSelfie == "YES" then
			return
		end
	elseif not AuraUtil.FindAuraByName(L["S.E.L.F.I.E. Camera"], "player") and not AuraUtil.FindAuraByName(L["S.E.L.F.I.E. Camera MkII"], "player") then
		if SHConfig.TakingSelfie == "YES" then
		
			if IsAddOnLoaded("TomTom") == true then
				TomTomBlock:Show()
			end
		
			if IsAddOnLoaded("Decursive") == true then
				DcrMUFsContainer:Show()
			end
		
			SHConfig.TakingSelfie = 'NO'
				
			if SHConfig.OwnName == "ON" then SetCVar("UnitNameOwn", "1") end
			if SHConfig.GuildName == "ON" then SetCVar("UnitNamePlayerGuild", "1") end
			if SHConfig.FriendlyPlayerName == "ON" then SetCVar("UnitNameFriendlyPlayerName", "1") end
			if SHConfig.FriendlyPetName == "ON" then SetCVar("UnitNameFriendlyPetName", "1") end
			if SHConfig.EnemyPlayerName == "ON" then SetCVar("UnitNameEnemyPlayerName", "1") end
			if SHConfig.EnemyPetName == "ON" then SetCVar("UnitNameEnemyPetName", "1") end
			if SHConfig.NPCName == "ON" then SetCVar("UnitNameNPC", "1") end
			if SHConfig.FriendlyGuardianName == "ON" then SetCVar("UnitNameFriendlyGuardianName", "1") end
			if SHConfig.EnemyGuardianName == "ON" then SetCVar("UnitNameEnemyGuardianName", "1") end
			if SHConfig.CompanionName == "ON" then SetCVar("UnitNameCompanionName", "1") end
			SetCVar("nameplateMaxDistance", tonumber(SHConfig.NamePlates))
		end
	end
end

end

function checksettings()

-- Probably not the BEST way of doing this, but it works!

local npdist = GetCVar("nameplateMaxDistance")
SHConfig.NamePlates = npdist

if GetCVar("UnitNameOwn") == "0" then
	SHConfig.OwnName = 'OFF'
elseif GetCVar("UnitNameOwn") == "1" then
	SHConfig.OwnName = 'ON'
end

if GetCVar("UnitNamePlayerGuild") == "0" then
	SHConfig.GuildName = 'OFF'
elseif GetCVar("UnitNamePlayerGuild") == "1" then
	SHConfig.GuildName = 'ON'
end

if GetCVar("UnitNameFriendlyPlayerName") == "0" then
	SHConfig.FriendlyPlayerName = 'OFF'
elseif GetCVar("UnitNameFriendlyPlayerName") == "1" then
	SHConfig.FriendlyPlayerName = 'ON'
end

if GetCVar("UnitNameFriendlyPetName") == "0" then
	SHConfig.FriendlyPetName = 'OFF'
elseif GetCVar("UnitNameFriendlyPetName") == "1" then
	SHConfig.FriendlyPetName = 'ON'
end

if GetCVar("UnitNameEnemyPlayerName") == "0" then
	SHConfig.EnemyPlayerName = 'OFF'
elseif GetCVar("UnitNameEnemyPlayerName") == "1" then
	SHConfig.EnemyPlayerName = 'ON'
end

if GetCVar("UnitNameEnemyPetName") == "0" then
	SHConfig.EnemyPetName = 'OFF'
elseif GetCVar("UnitNameEnemyPetName") == "1" then
	SHConfig.EnemyPetName = 'ON'
end

if GetCVar("UnitNameNPC") == "0" then
	SHConfig.NPCName = 'OFF'
elseif GetCVar("UnitNameNPC") == "1" then
	SHConfig.NPCName = 'ON'
end

if GetCVar("UnitNameFriendlyGuardianName") == "0" then
	SHConfig.FriendlyGuardianName = 'OFF'
elseif GetCVar("UnitNameFriendlyGuardianName") == "1" then
	SHConfig.FriendlyGuardianName = 'ON'
end

if GetCVar("UnitNameEnemyGuardianName") == "0" then
	SHConfig.EnemyGuardianName = 'OFF'
elseif GetCVar("UnitNameEnemyGuardianName") == "1" then
	SHConfig.EnemyGuardianName = 'ON'
end

if GetCVar("UnitNameCompanionName") == "0" then
	SHConfig.CompanionName = 'OFF'
elseif GetCVar("UnitNameCompanionName") == "1" then
	SHConfig.CompanionName = 'ON'
end

end